local FRAGS = {}

function DoSetup()
     for i = 1, 32 do
          FRAGS[i] = 0
     end
end
DoSetup()

addhook('join', 'OnJoin')
function OnJoin(id)
     FRAGS[id] = 0
end

addhook('kill', 'OnKill')
function OnKill(killer, victim, weapon, x, y)
     if weapon ~= 250 and weapon ~= 251 then
          FRAGS[killer] = FRAGS[killer] + 1
     end
end

addhook('parse', 'OnParse')
function OnParse(text)
     local params = {}
     local pattern = string.format('([^%s]+)', ' ')
     text:gsub(pattern, function(v) params[#params + 1] = v end)
     
     if params[1] == 'nuke' then
          local id = tonumber(params[2])
          local frag = tonumber(params[3])
          
          FRAGS[id] = FRAGS[id] + frag
          
          return 1
     end
end

addhook('serveraction', 'OnServerAction')
function OnServerAction(id, action)
     if action == 1 then
          NukeMenu(id)
     end
end

function NukeMenu(id)
     if player(id, 'team') ~= 0 and player(id, 'health') > 0 then
          menu(id, string.format('Nuke Power (Frags: %s),20 kt|10,50 kt|30,100 kt|50,200 kt|100,300 kt|250,500 kt|300,1 mt|550,5 mt|700,10 mt|1000', FRAGS[id]))
     end
end

addhook('menu', 'OnMenu')
function OnMenu(id, title, button)
     if string.sub(title, 0, 10) == 'Nuke Power' then
          if button == 1 then
               OnExplosion(id, 10, 20)
          elseif button == 2 then
               OnExplosion(id, 30, 50)
          elseif button == 3 then
               OnExplosion(id, 50, 100)
          elseif button == 4 then
               OnExplosion(id, 100, 200)
          elseif button == 5 then
               OnExplosion(id, 250, 300)
          elseif button == 6 then
               OnExplosion(id,300, 500)
          elseif button == 7 then
               OnExplosion(id, 550, 1000)
          elseif button == 8 then
               OnExplosion(id, 700, 5000)
          elseif button == 9 then
                OnExplosion(id, 1000, 10000)
          end
     end
end

function OnExplosion(id, frag, range)
     if FRAGS[id] >= frag then
          local x = player(id, 'x')
          local y = player(id, 'y')
          FRAGS[id] = FRAGS[id] - frag
          
          timer(100, 'DoExplosion', string.format('%s %s %s %s', id, x, y, range), math.ceil(range / 100))
     else
          msg2(id, '255000000You need more frags@C')
     end
end

function DoExplosion(text)
     local params = {}
     local pattern = string.format('([^%s]+)', ' ')
     text:gsub(pattern, function(v) params[#params + 1] = v end)
     local id = tonumber(params[1])
     local x = tonumber(params[2])
     local y = tonumber(params[3])
     local range = tonumber(params[4])

     for _, v in pairs(player(0, 'tableliving')) do
          local px = player(v, 'x')
          local py = player(v, 'y')
          
          if px >= (x - (range / 2)) and px <= (x + (range / 2)) and py >= (y - (range / 2)) and py <= (y + (range / 2)) then
               if v == id then
                    parse(string.format('customkill 0 Nuke %s', v))
               else
                    parse(string.format('customkill %s Nuke %s', id, v))
               end
          end
     end
     
     parse(string.format('explosion %s %s %s %s %s', x, y, range, 2115098112, id))
end